//
//  $Id: Error.h,v 1.3 2000/06/04 23:23:52 sergey Exp $
//

#ifndef _Error_h_
#define _Error_h_


namespace Util
{
    //
    // Error handler interface.
    //
    class ErrorHandler
    {
    public:
        virtual ~ErrorHandler() {}

        virtual void reportError(bool fatal, const char* message) = 0;
    };


    //
    // Error class used to report fatal system errors.
    //
    class Error
    {
    private:
        Error() {}
        ~Error() {}

    // error handler operations
    public:
        static ErrorHandler& errorHandler()                         { return *_errorHandler; }
        static void setErrorHandler(ErrorHandler& errorHandler)     { _errorHandler = &errorHandler; }

    // generic error messages

        static void errorMessage0(bool fatal, const char* message);
        static void errorMessage(bool fatal, const char* format, ...);

    // standard system errors

        static void memoryAllocationError(const char* file, int line);
        static void findLibraryError(const char* libName);

    private:
        static ErrorHandler* _errorHandler;     // current error handler
    };
};

#endif  // _Error_h_
